﻿Imports System.IO

''' <summary>
''' (Modul) Stellt die Methode <see cref="UrsExtendedMsgBoxModule.MsgBoxEx"/> bereit, die ein erweitertes Nachrichtenfenster ohne Angabe eines Klassennamens anzeigt.
''' </summary>
Public Module UrsExtendedMsgBoxModule
#Region " MsgBoxEx "
      ''' <summary>
      ''' Erzeugt eine erweiterte MessageBox und zeigt sie an.
      ''' </summary>
      ''' <param name="Prompt">Die anzuzeigende Nachricht.</param>
      ''' <param name="MsgType">Optional. Art des zu verwendenden Symbols. Standard ist <see cref="UrsExtendedMsgBox.MsgTypes.Information"/>.</param>
      ''' <param name="Title">Optional. Auf der Titelleiste des Dialogfelds angezeigter String-Ausdruck. Wenn Caption nicht angeben wird, 
      ''' wird der Anwendungsname auf der Titelleiste platziert (siehe <see cref="UrsExtendedMsgBox.Caption"/>-Eigenschaft).</param>
      ''' <param name="Buttons">Optional. Anzahl und Art der anzuzeigenden Schaltflächen. Standard ist <see cref="UrsExtendedMsgBox.ButtonList.OkOnly"/> 
      ''' (siehe <see cref="UrsExtendedMsgBox.Buttons"/>-Eigenschaft).</param>
      ''' <param name="DefaultButton">Optional. Angabe der Standardschaltfläche. Standard ist <see cref="UrsExtendedMsgBox.DefaultButtons.Button1"/> 
      ''' (siehe <see cref="UrsExtendedMsgBox.DefaultButton"/>-Eigenschaft).</param>
      ''' <param name="SoundType">Optionl. Legt fest, ob beim Anzeigen der Meldung ein Signalton ausgegeben wird und welcher. Standard is <see cref="UrsExtendedMsgBox.SoundTypes.None"/>
      ''' (siehe <see cref="UrsExtendedMsgBox.SoundType"/>-Eigenschaft).</param>
      ''' <param name="SoundStream">Ein <see cref="Stream"/>-Objekt, das die Audiodatei darstellt (siehe <see cref="UrsExtendedMsgBox.SoundStream"/>-Eigenschaft. Die Angabe wird benötigt, 
      ''' wenn der Parameter <paramref name="SoundType"/> den Wert <see cref="UrsExtendedMsgBox.SoundTypes.Manual"/> besitzt.</param>
      ''' <param name="ShowCopyButton">Optional. Legt fest, ob die Schaltfläche 'Meldung kopieren' angezeigt wird. Standard ist <b>False</b>
      ''' (siehe <see cref="UrsExtendedMsgBox.ShowCopyButton"/>-Eigenschaft).</param>
      ''' <param name="TopMost">Optional. Legt fest, ob das Nachrichtenfenster als oberstes Fenster erscheinen soll (siehe <see cref="UrsExtendedMsgBox.TopMost"/>-Eigenschaft).</param>
      ''' <param name="IconSize">Größe des angezeigten Symbols (siehe <see cref="UrsExtendedMsgBox.IconSize"/>-Eigenschaft).</param>
      ''' <param name="StartPosition">Legt die Anfangsposition des Nachrichtenfensters zur Laufzeit fest (siehe <see cref="UrsExtendedMsgBox.Startposition"/>-Eigenschaft).</param>
      ''' <param name="Location">Legt die Position der linken oberen Ecke des Nachrichtenfensters in Bildschirmkoordinaten fest, wenn der Parameter <paramref name="StartPosition"/>
      ''' den Wert <see cref="UrsExtendedMsgBox.StartPositions.Manual"/> besitzt (siehe <see cref="UrsExtendedMsgBox.Location"/>-Eigenschaft).</param>
      ''' <param name="Parent">Ein Control, das das übergeordnete Element oder das Container-Steuerelement des Nachrichtenfensters darstellt 
      ''' (siehe <see cref="UrsExtendedMsgBox.Parent"/>-Eigenschaft).</param>
      ''' <returns>Einer der <see cref="DialogResult"/>-Werte.<para/>
      ''' Wenn das Nachrichtenfenster durch klicken auf die "Schließen" in der Titelleiste geschlossen
      ''' wurde, wird der wert <see cref="DialogResult.Cancel">Cancel</see> zurück geliefert.</returns>
      ''' <seealso cref="MsgBoxResult"/>
      Public Function MsgBoxEx(Prompt As String,
                               Optional MsgType As UrsExtendedMsgBox.MsgTypes = UrsExtendedMsgBox.MsgTypes.Information,
                               Optional Title As String = Nothing,
                               Optional Buttons As UrsExtendedMsgBox.ButtonList = UrsExtendedMsgBox.ButtonList.OkOnly,
                               Optional DefaultButton As UrsExtendedMsgBox.DefaultButtons = UrsExtendedMsgBox.DefaultButtons.Button1,
                               Optional SoundType As UrsExtendedMsgBox.SoundTypes = UrsExtendedMsgBox.SoundTypes.None,
                               Optional SoundStream As Stream = Nothing,
                               Optional ShowCopyButton As Boolean = False,
                               Optional TopMost As Boolean = False,
                               Optional IconSize As UrsExtendedMsgBox.IconSizes = UrsExtendedMsgBox.IconSizes.Icons32,
                               Optional StartPosition As UrsExtendedMsgBox.StartPositions = UrsExtendedMsgBox.StartPositions.CenterParent,
                               Optional Location As Point = Nothing,
                               Optional Parent As Form = Nothing) As DialogResult

         Dim a As New UrsExtendedMsgBox(Prompt, MsgType, Title, Buttons, DefaultButton, SoundType, SoundStream,
                               ShowCopyButton, False, TopMost, IconSize, StartPosition, Location, Parent)
         Return a.ShowDialog()
      End Function

      ''' <summary>
      ''' Erzeugt eine erweiterte MessageBox und zeigt sie an.
      ''' </summary>
      ''' <param name="Prompt">Die anzuzeigende Nachricht.</param>
      ''' <param name="Style">Numerischer Ausdruck, der die Summe der Werte für folgende Angaben darstellt: Anzahl und Art der anzuzeigenden Schaltflächen, 
      ''' Art des zu verwendenden Symbols, Angabe der Standardschaltfläche und Verhalten des Meldungsfelds. Der Standardwert ist 0 (null).</param>
      ''' <param name="Title">Optional. Auf der Titelleiste des Dialogfelds angezeigter String-Ausdruck. Wenn Caption nicht angeben wird, 
      ''' wird der Anwendungsname auf der Titelleiste platziert (siehe <see cref="UrsExtendedMsgBox.Caption"/>-Eigenschaft).</param>
      ''' <param name="SoundType">Optionl. Legt fest, ob beim Anzeigen der Meldung ein Signalton ausgegeben wird und welcher. Standard is <see cref="UrsExtendedMsgBox.SoundTypes.None"/>
      ''' (siehe <see cref="UrsExtendedMsgBox.SoundType"/>-Eigenschaft).</param>
      ''' <param name="SoundStream">Ein <see cref="Stream"/>-Objekt, das die Audiodatei darstellt (siehe <see cref="UrsExtendedMsgBox.SoundStream"/>-Eigenschaft). Die Angabe wird benötigt, 
      ''' wenn der Parameter <paramref name="SoundType"/> den Wert <see cref="UrsExtendedMsgBox.SoundTypes.Manual"/> besitzt.</param>
      ''' <param name="ShowCopyButton">Optional. Legt fest, ob die Schaltfläche 'Meldung kopieren' angezeigt wird. Standard ist <b>False</b>
      ''' (siehe <see cref="UrsExtendedMsgBox.ShowCopyButton"/>-Eigenschaft).</param>
      ''' <param name="IconSize">Größe des angezeigten Symbols (siehe <see cref="UrsExtendedMsgBox.IconSize"/>-Eigenschaft).</param>
      ''' <param name="StartPosition">Legt die Anfangsposition des Nachrichtenfensters zur Laufzeit fest (siehe <see cref="UrsExtendedMsgBox.Startposition"/>-Eigenschaft).</param>
      ''' <param name="Location">Legt die Position der linken oberen Ecke des Nachrichtenfensters in Bildschirmkoordinaten fest, wenn der Parameter <paramref name="StartPosition"/>
      ''' den Wert <see cref="UrsExtendedMsgBox.StartPositions.Manual"/> besitzt (siehe <see cref="UrsExtendedMsgBox.Location"/>-Eigenschaft).</param>
      ''' <param name="Parent">Ein Control, das das übergeordnete Element oder das Container-Steuerelement des Nachrichtenfensters darstellt 
      ''' (siehe <see cref="UrsExtendedMsgBox.Parent"/>-Eigenschaft).</param>
      ''' <returns>Einer der <see cref="DialogResult"/>-Werte.<para/>
      ''' Wenn das Nachrichtenfenster durch klicken auf die "Schließen" in der Titelleiste geschlossen
      ''' wurde, wird der wert <see cref="DialogResult.Cancel">Cancel</see> zurück geliefert.</returns>
      ''' <seealso cref="MsgBoxResult"/>
      ''' <remarks>Der Parameter <paramref name="Style"/> enspricht im wesentlichen dem Parameter <b>Buttons</b> bei der <see cref="MsgBox"/>-Methode.</remarks>
      Public Function MsgBoxEx(Prompt As String,
                               Style As UrsExtendedMsgBox.MsgBoxExStyle,
                               Optional Title As String = Nothing,
                               Optional SoundType As UrsExtendedMsgBox.SoundTypes = UrsExtendedMsgBox.SoundTypes.None,
                               Optional SoundStream As Stream = Nothing,
                               Optional ShowCopyButton As Boolean = False,
                               Optional IconSize As UrsExtendedMsgBox.IconSizes = UrsExtendedMsgBox.IconSizes.Icons32,
                               Optional StartPosition As UrsExtendedMsgBox.StartPositions = UrsExtendedMsgBox.StartPositions.CenterParent,
                               Optional Location As Point = Nothing,
                               Optional Parent As Form = Nothing) As DialogResult

         Dim MsgType As UrsExtendedMsgBox.MsgTypes = UrsExtendedMsgBox.MsgTypes.None
         Select Case Style And (UrsExtendedMsgBox.MsgBoxExStyle.Critical Or UrsExtendedMsgBox.MsgBoxExStyle.Question Or
                                UrsExtendedMsgBox.MsgBoxExStyle.Exclamation Or UrsExtendedMsgBox.MsgBoxExStyle.Information)
            Case UrsExtendedMsgBox.MsgBoxExStyle.Critical
               MsgType = UrsExtendedMsgBox.MsgTypes.Error
            Case UrsExtendedMsgBox.MsgBoxExStyle.Question
               MsgType = UrsExtendedMsgBox.MsgTypes.Question
            Case UrsExtendedMsgBox.MsgBoxExStyle.Exclamation
               MsgType = UrsExtendedMsgBox.MsgTypes.Warning
            Case UrsExtendedMsgBox.MsgBoxExStyle.Information
               MsgType = UrsExtendedMsgBox.MsgTypes.Information
         End Select

         Dim TopMost As Boolean = (Style And UrsExtendedMsgBox.MsgBoxExStyle.MsgBoxSetForeground) <> 0

         Dim DefaultButton As UrsExtendedMsgBox.DefaultButtons = UrsExtendedMsgBox.DefaultButtons.Button1
         Select Case Style And (UrsExtendedMsgBox.MsgBoxExStyle.DefaultButton1 Or UrsExtendedMsgBox.MsgBoxExStyle.DefaultButton2 Or UrsExtendedMsgBox.MsgBoxExStyle.DefaultButton3)
            Case UrsExtendedMsgBox.MsgBoxExStyle.DefaultButton2
               DefaultButton = UrsExtendedMsgBox.DefaultButtons.Button2
            Case UrsExtendedMsgBox.MsgBoxExStyle.DefaultButton3
               DefaultButton = UrsExtendedMsgBox.DefaultButtons.Button3
         End Select

         Dim Buttons As UrsExtendedMsgBox.ButtonList = UrsExtendedMsgBox.ButtonList.OkOnly
         Select Case Style And (UrsExtendedMsgBox.MsgBoxExStyle.OkOnly Or UrsExtendedMsgBox.MsgBoxExStyle.OkCancel Or UrsExtendedMsgBox.MsgBoxExStyle.RetryCancel Or
                                UrsExtendedMsgBox.MsgBoxExStyle.YesNo Or UrsExtendedMsgBox.MsgBoxExStyle.YesNoCancel Or UrsExtendedMsgBox.MsgBoxExStyle.AbortRetryIgnore)
            Case UrsExtendedMsgBox.MsgBoxExStyle.OkCancel
               Buttons = UrsExtendedMsgBox.ButtonList.OkCancel
            Case UrsExtendedMsgBox.MsgBoxExStyle.RetryCancel
               Buttons = UrsExtendedMsgBox.ButtonList.RetryCancel
            Case UrsExtendedMsgBox.MsgBoxExStyle.YesNo
               Buttons = UrsExtendedMsgBox.ButtonList.YesNo
            Case UrsExtendedMsgBox.MsgBoxExStyle.YesNoCancel
               Buttons = UrsExtendedMsgBox.ButtonList.YesNoCancel
            Case UrsExtendedMsgBox.MsgBoxExStyle.AbortRetryIgnore
               Buttons = UrsExtendedMsgBox.ButtonList.AbortRetryIgnore
         End Select

         Dim a As New UrsExtendedMsgBox(Prompt, MsgType, Title, Buttons, DefaultButton, SoundType, SoundStream,
                               ShowCopyButton, False, TopMost, IconSize, StartPosition, Location, Parent)
         Return a.ShowDialog()
      End Function
#End Region
End Module